<?php
/**
* @version		1.0
* @package		DJ Classifieds
* @subpackage	DJ Classifieds Payment Plugin
* @copyright	Copyright (C) 2010 DJ-Extensions.com LTD, All rights reserved.
* @license		http://www.gnu.org/licenses GNU/GPL
* @autor url    http://design-joomla.eu
* @autor email  contact@design-joomla.eu
* @Developer    Lukasz Ciastek - lukasz.ciastek@design-joomla.eu
* 
* 
* DJ Classifieds is free software: you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* DJ Classifieds is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with DJ Classifieds. If not, see <http://www.gnu.org/licenses/>.
* 
*/
defined('_JEXEC') or die('Restricted access');
jimport('joomla.event.plugin');
$lang = & JFactory::getLanguage();
$lang->load('plg_djclassifiedspayment_djcfPrzelewy24',JPATH_ADMINISTRATOR);
class plgdjclassifiedspaymentdjcfPrzelewy24 extends JPlugin
{
	function plgdjclassifiedspaymentdjcfPrzelewy24( &$subject, $config)
	{
		parent::__construct($subject, $config);
		$this->loadLanguage('plg_djcfPrzelewy24');
		$params["plugin_name"] = "djcfPrzelewy24";
		$params["icon"] = "przelewy24_icon.png";
		$params["logo"] = "przelewy24_overview.png";
		$params["description"] = JText::_("PLG_DJCFPRZELEWY24_PAYMENT_METHOD_DESC");
		$params["payment_method"] = JText::_("PLG_DJCFPRZELEWY24_PAYMENT_METHOD_NAME");
		$params["testmode"] = $this->params->get("test");
		$params["currency_code"] = $this->params->get("currency_code");
		$params["p24_id"] = $this->params->get("p24_id");
		$params["p24_crc"] = $this->params->get("p24_crc");
		$this->params = $params;

	}
	
	function onPaymentMethodList($val)
	{
		$html ='';
		$user = JFactory::getUser();
		if($this->params["p24_id"]!='' && $this->params["p24_crc"]!=''){
			$paymentLogoPath = JURI::root()."plugins/djclassifiedspayment/".$this->params["plugin_name"]."/".$this->params["plugin_name"]."/images/".$this->params["logo"];
			$form_action = JRoute :: _("index.php?option=com_djclassifieds&task=processPayment&ptype=".$this->params["plugin_name"]."&pactiontype=process&id=".$val["id"], false);
			$html ='
				<form action="index.php" method="get" class="form-validate" id="djcf_p24" name="djcf_p24" >
					<input type="hidden" name="option" value="com_djclassifieds" />
					<input type="hidden" name="task" value="processPayment" />
					<input type="hidden" name="ptype" value="'.$this->params["plugin_name"].'" />
					<input type="hidden" name="pactiontype" value="process" />
					<input type="hidden" name="id" value="'.$val["id"].'" />
					<table cellpadding="5" cellspacing="0" width="100%" border="0">
					<tr>';
						if($this->params["logo"] != ""){
					$html .='<td class="td1" width="160" align="center">
							<img src="'.$paymentLogoPath.'" title="'. $this->params["payment_method"].'"/>
						</td>';
						 }
						$html .='<td class="td2">
							<h2>Przelewy 24</h2>
							<p style="text-align:justify;">'.$this->params["description"].'</p>';
							if($user->id==0){
								$html .='<div class="email_box"><span>'.JText::_('JGLOBAL_EMAIL').':*</span> <input size="50" class="validate-email required" type="text" name="email" value=""></div>';
							}							
						$html.='</td>
						<td  class="td3" width="100" align="center">
							<input type="image" class="image_submit" border="0" src="'.JURI::root().'components/com_djclassifieds/assets/images/buynow.png" width="89" height="28" />
						</td>
					</tr>
				</table>
			</form>';
		}
		return $html;
	}	
	
	function onProcessPayment()
	{
		$ptype = JRequest::getVar('ptype','');
		$id = JRequest::getInt('id','0');
		$html="";

			
		if($ptype == $this->params["plugin_name"])
		{
			$action = JRequest::getVar('pactiontype','');
			switch ($action)
			{
				case "process" :
				$html = $this->process($id);
				break;
				case "notify" :
				$html = $this->_notify_url();
				break;
				case "paymentmessage" :
				$html = $this->_paymentsuccess();
				break;
				default :
				$html =  $this->process($id);
				break;
			}
		}
		return $html;
	}
	function _notify_url()
	{
		$db = JFactory::getDBO();
		$par = JComponentHelper::getParams( 'com_djclassifieds' );

		$user	= JFactory::getUser();
		$id	= JRequest::getInt('id','0');
		$app = JFactory::getApplication();
		$itemid = JRequest::getInt("Itemid","");	
		
		$przelewy24_info = $_POST;
		$przelewy24_ipn = new przelewy24_ipn();		
		
		$p24_session_id = $_POST["p24_session_id"];
		$p24_order_id = $_POST["p24_order_id"];
		$p24_id_sprzedawcy = $this->params["p24_id"];
		
			$query ="SELECT i.*, c.price as c_price FROM #__djcf_items i "
				    ."LEFT JOIN #__djcf_categories c ON c.id=i.cat_id "
			   		."WHERE i.id=".$id." LIMIT 1";
			$db->setQuery($query);
			$item = $db->loadObject();
			
			$p24_kwota = 0;
			if(strstr($item->pay_type, 'special,')){			
				$p24_kwota = $par->get('prom_price','0') * 100;
			}
			if(strstr($item->pay_type, 'cat')){			
				$p24_kwota += $item->c_price;
			}
		
		//		$p24_kwota = WYNIK POBRANY Z TWOJEJ BAZY (w groszach)

		$res =	$przelewy24_ipn->send_response($p24_id_sprzedawcy, $p24_session_id, $p24_order_id, $p24_kwota, $this->params);

		//print_R($res);die();
		if ($res[0]!='TRUE'){
			$message=JTExt::_('PLG_DJCFPRZELEWY24_AFTER_ERROR_MSG');
			$redirect= 'index.php?option=com_djclassifieds&view=items&cid=0&Itemid='.$itemid;
			$app->redirect($redirect, $message);
			die();
		} else {
				
				$query = "UPDATE #__djcf_payments SET status='Completed',transaction_id='".$p24_session_id."' "
						."WHERE item_id=".$id." AND method='djcfPrzelewy24'";
				$db->setQuery($query);
				$db->query();
				
				$query = "SELECT c.*  FROM #__djcf_items i, #__djcf_categories c "
						."WHERE i.cat_id=c.id AND i.id='".$id."' ";
				$db->setQuery($query);
				$cat = $db->loadObject();
				
				$pub=0;
				if(($cat->autopublish=='1') || ($cat->autopublish=='0' && $par->get('autopublish')=='1')){						
					$pub = 1;							 						
				}
		
				$query = "UPDATE #__djcf_items SET payed=1, pay_type='', published='".$pub."' "
						."WHERE id=".$id." ";					
				$db->setQuery($query);
				$db->query();
		}	
				
		$message=JTExt::_('PLG_DJCFPRZELEWY24_AFTER_SUCCESSFULL_MSG');
		$redirect= 'index.php?option=com_djclassifieds&view=items&cid=0&Itemid='.$itemid;
		$app->redirect($redirect, $message);
		
	}
	
	function process($id)
	{
		$db = JFactory::getDBO();
		$app = JFactory::getApplication();
		$Itemid = JRequest::getInt("Itemid",'0');
		$par = JComponentHelper::getParams( 'com_djclassifieds' );
		$user = JFactory::getUser();
		$ptype=JRequest::getVar('ptype');

		$query ="SELECT i.*, c.price as c_price FROM #__djcf_items i "
			   ."LEFT JOIN #__djcf_categories c ON c.id=i.cat_id "
			   ."WHERE i.id=".$id." LIMIT 1";
		$db->setQuery($query);
		$item = $db->loadObject();
		if(!isset($item)){
			$message = JText::_('COM_DJCLASSIFIEDS_WRONG_AD');
			$redirect="index.php?option=com_djclassifieds&view=items&cid=0";
		}
		
			$query = 'DELETE FROM #__djcf_payments WHERE item_id= "'.$id.'" ';
			$db->setQuery($query);
			$db->query();
			
			
			$query = 'INSERT INTO #__djcf_payments ( item_id,user_id,method,  status)' .
					' VALUES ( "'.$id.'" ,"'.$user->id.'","'.$ptype.'" ,"Start" )'
					;
			$db->setQuery($query);
			$db->query();
			
		
			$amount = 0;
			if(strstr($item->pay_type, 'cat')){
				$amount += ($item->c_price);
			}
			if(strstr($item->pay_type, 'duration')){			
				$query = "SELECT d.price FROM #__djcf_days d "
				."WHERE d.days=".$item->exp_days;
				$db->setQuery($query);
				$amount += ($db->loadResult() * 100);
			}
			
			$query = "SELECT p.* FROM #__djcf_promotions p "
				."WHERE p.published=1 ORDER BY p.id ";
			$db->setQuery($query);
			$promotions=$db->loadObjectList();
			foreach($promotions as $prom){
				if(strstr($item->pay_type, $prom->name)){	
					$amount += ($prom->price * 100); 
				}	
			}

		if($user->id>0){
			$email = $user->email;
		}else{
			$email = JRequest::getVar('email','');
		}
							
		$itemname = $item->name;
		$przelewy24URL = 'https://secure.przelewy24.pl/index.php';
		if ($this->params["testmode"]=="1"){
			$itemname = 'TEST_OK';
			$przelewy24URL = 'https://sandbox.przelewy24.pl/index.php';
			//$itemname = 'TEST_ERR';
		}
		
		$crc_hash = md5($item->id.'|'.$this->params["p24_id"].'|'.$amount.'|'.$this->params["p24_crc"]);

		echo JText::_('PLG_DJCFPRZELEWY24_REDIRECTING_PLEASE_WAIT');
			
			$form ='<form id="przelewy24form" action="'.$przelewy24URL.'" method="post">';
			$form .='<br /><input type="hidden" id="p24_session_id" name="p24_session_id" value="'.$item->id.'">';
			$form .='<br /><input type="hidden" name="p24_id_sprzedawcy" value="'.$this->params["p24_id"].'">';
			$form .='<br /><input type="hidden" name="p24_kwota" value="'.$amount.'">';
			$form .='<br /><input type="hidden" name="p24_email" value="'.$email.'">';
	
			$form .='<br /><input type="hidden" name="p24_return_url_ok" value="'.JRoute::_(JURI::base().'index.php?option=com_djclassifieds&task=processPayment&ptype='.$this->params["plugin_name"].'&pactiontype=notify&id='.$item->id.'&Itemid='.$Itemid).'">';
			$form .='<br /><input type="hidden" name="p24_return_url_error" value="'.JRoute::_(JURI::base().'index.php?option=com_djclassifieds&task=paymentReturn&r=error&id='.$item->id.'&cid='.$item->cat_id.'&Itemid='.$Itemid).'">';
			
			$form .='<br /><input type="hidden" name="p24_metoda" value="">';
			$form .='<br /><input type="hidden" name="p24_opis" value="'.$itemname.'">';
			$form .='<br /><input type="hidden" name="p24_language" value="pl">';
			
			$form .='<br /><input type="hidden" name="p24_crc" value="'.$crc_hash.'">';
			$form .='</form>';
		echo $form;
		
	?>
		<script type="text/javascript">
			callpayment()
			function callpayment(){
				var id = document.getElementById('p24_session_id').value ;
				if ( id > 0 && id != '' ) {
					document.getElementById('przelewy24form').submit();
				}
			}
		</script>
	<?php
	die();
	}


}
class przelewy24_ipn{
	
	
	function send_response($p24_id_sprzedawcy, $p24_session_id, $p24_order_id, $p24_kwota="", $plgParams){
		
		$testmode = $plgParams['testmode'];
		$p24_crc = $plgParams['p24_crc'];
		
		$P = array(); $RET = array();
		if($testmode) $url = "https://sandbox.przelewy24.pl/transakcja.php";
		else $url = "https://secure.przelewy24.pl/transakcja.php";
		$P[] = "p24_id_sprzedawcy=".$p24_id_sprzedawcy;
		$P[] = "p24_session_id=".$p24_session_id;
		$P[] = "p24_order_id=".$p24_order_id;
		$P[] = "p24_kwota=".$p24_kwota;
		$P[] = "p24_crc=".md5($p24_session_id."|". $p24_order_id."|". $p24_kwota."|".$p24_crc);
		$user_agent = "Mozilla/4.0 (compatible; MSIE 5.01; Windows NT 5.0)";
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_POST,1);
		if(count($P)) curl_setopt($ch, CURLOPT_POSTFIELDS,join("&",$P));
			curl_setopt($ch, CURLOPT_URL,$url);
			curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
			curl_setopt($ch, CURLOPT_USERAGENT, $user_agent);
			curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
			curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		$result=curl_exec ($ch);
		curl_close ($ch);
		$T = explode(chr(13).chr(10),$result);
		$res = false;
		
		foreach($T as $line){
			$line = ereg_replace("[\n\r]","",$line);
			if($line != "RESULT" and !$res) continue;
			if($res) $RET[] = $line;
			else $res = true;
		}
		return $RET;
	}

	
}
?>